/***********************************************************************************
BEURTEILUNG für Aufgabe 1:  27 Punkte

        Deklaration und Initialisierung: 10
        'prescribe':                     7
        'medicines':                     10

Hier ist ein Beispiel für die wesentlichen Teile einer Lösung:

    private Map<String, String[]> registry = new TreeMap<String, String[]>();

    public Capsule(Queue<String> patients, Queue<String[]> medicines) {
        String a;
        while ((a = patients.poll()) != null) {
            registry.put(a, medicines.poll());
        }
    }

    public boolean prescribe(String medicine, String patient) {
        if (medicine == null || patient == null) {
            return false;
        }
        String[] meds = registry.get(patient);
        if (meds == null) {
            registry.put(patient, new String[]{medicine});
        } else {
            String[] newMeds = new String[meds.length + 1];
            for (int i = 0; i < meds.length; i++) {
                if (medicine.equals(meds[i])) {
                    return false;
                }
                newMeds[i] = meds[i];
            }
            newMeds[meds.length] = medicine;
            registry.put(patient, newMeds);
        }
        return true;
    }

    public Queue<String> medicines(String patient) {
        String[] meds;
        if (patient == null || (meds = registry.get(patient)) == null) {
            return null;
        }
        Queue<String> q = new LinkedList<String>();
        for (String p : meds) {
            q.offer(p);
        }
        return q;
    }

***********************************************************************************/
import java.util.*;

/*
Lesen Sie die Aufgaben genau durch.
Schreiben bzw. vervollständigen Sie gekennzeichnete Programmteile wie in den Kommentaren beschrieben.
Verändern Sie aber nicht vorgegebene Methodenköpfe oder andere vorgegebene Programmteile!
*/
public class Capsule {

    /*
    Aufgabe:
        Objekte der Klasse Capsule stellen einfache Verzeichnisse von Medikamentenverschreibungen (prescription) in
        einem Krankenhaus dar. Für eine gegebene Person (Patient oder Patientin) können die verschriebenen Medikamente
        ermittelt werden.

        Die Bezeichnungen aller Medikamente, die einer Person verschrieben wurden, sollen in einem String-Array
        abgelegt werden. Für alle anderen Zwecke dürfen in dieser Aufgabe keine Arrays verwendet werden.
        Stattdessen sollen Datenstrukturen wie Queue und Map verwendet werden.

        Ergänzen Sie fehlende Teile der Klasse entsprechend den Kommentaren an den mit TODO gekennzeichneten Stellen.

    Punkte (maximal 30):
        10 Punkte für die Deklaration und Initialisierung der nötigen Objektvariablen (einschließlich Konstruktor),
        10 Punkte für die Implementierung von 'prescribe',
        10 Punkte für die Implementierung von 'medicines',

        Auch für teilweise korrekte Lösungen werden Punkte vergeben.
    */


    // Object variables shall be visible only within the class.
    // TODO: Declaration and initialization of object variables is your task.


    // Initialize new object:
    // 'patients' contains names of patients and 'medicines' all medicines prescribed to these
    // patients. It is assumed that 'patients' and 'medicines' are not null and the queues are of the same length.
    // The first element in 'patients' corresponds to the first element in 'medicines', the second to the second, etc.
    // If no medicine is prescribed to a patient, then the corresponding element in 'medicines' is an array of length 0.
    public Capsule(Queue<String> patients, Queue<String[]> medicines) {
        // TODO: Implementation is your task.

       
    // 'prescribe' tries to add a new medicine 'medicine' to the medicines prescribed to patient 'patient'.
    // If 'medicine' or 'patient' is null or 'medicine' is already prescribed to 'patient', then no medicine
    // is added and false is returned.
    // Otherwise 'medicine' is added (i.e., the corresponding array has to be extended) and true is returned.
    public boolean prescribe(String medicine, String patient) {
        // TODO: Implementation is your task.
       
    // 'medicines' returns the medicines of patient 'patient' in a queue.
    // If 'patient' is null or 'patient' is unknown, then 'medicines' returns null.
    // If 'patient' is known, but no medicine is prescribed to this patient, then 'medicines' returns an empty queue.
    // Medicines in the returned queue can occur in arbitrary ordering (beliebige Reihenfolge).
    public Queue<String> medicines(String patient) {
        // TODO: Implementation is your task.
        

    // Just for testing. Does not contribute to the assessment. Geht nicht in die Beurteilung ein.
    public static void main(String[] args) {

    }
}

